function m = felezo
% A felezo fggvny az intervallumfelezses mdszerrel
% megkeresi az f fggvny zrushelyt eps_abs pontossggal.

% x szimbolikus vltoz
syms x;

disp(' ')
f = input('rja be a fggvny kplett. \n');
% plda: x^2 - 4

disp(' ')
eps_abs = input('Pontossg? \n');

disp(' ')
a = input('rja be x als korltjt. \n');

disp(' ')
b = input('rja be x fels korltjt. \n');

disp(' ')
ymin = input('rja be az y tengely als hatrt. \n');

disp(' ')
ymax = input('rja be az y tengely fels hatrt. \n');

% subs(f, a): behelyettest f-be s kirtkel 
if ( subs(f, a) == 0 )
    m = a;
    return;
elseif ( subs(f, b) == 0 )
    m = b;
    return;
elseif ( subs(f, a) * subs(f, b) > 0 )
    error( 'f(a) s f(b) eljele nem klnbzik' );
end

disp(' ');
N = input('Iterci szma? \n');

% Mekkora intervallumot tekintnk tl kicsinek
eps_step = 0.001;

xmin = a;
xmax = b;

% Iterlunk N alkalommal, s ha a zrushelyet nem
% talltuk meg ezalatt, akkor hibazenettel megllunk.
for k = 1:N
    % Letrljk az elz brt.
    hold off;
    % Felrajzoljuk az x tengelyt.
    ezplot('0', [xmin, xmax])
    % Ezutn hozztesznk az brhoz.
    hold on;
    % f fggvnyt felrajzoljuk.
    ezplot(f, [xmin, xmax])
    % Az x s y tengely rdekes rszt mutatjuk.
    axis([xmin xmax ymin ymax])
    % Pirossal kijelljk az x tengelyen az [a, b] intervallumot
    line('XData', [a b], 'YData', [0 0], 'Color', [1 0 0], 'Marker', 'x');
    text(a, 0.2, 'a');
    text(b, 0.2, 'b');
    
    disp(' ')
    disp('ssn ENTER-t a folytatshoz vagy Ctrl^C-t a kilpshez')
    pause
    % Megkeressk az [a, b] intervallum kzppontjt.
    c = (a + b)/2;
    
    % Megtalltuk a gykt? 
    % Ha nem, az intervallum melyik felben folytassuk a keresst?
    %          [a, c]-ben, ha f(a) s f(c) eljele eltr, vagy
    %          [c, b]-ben, ha f(c) s f(b) eljele eltr.
    
    if ( subs(f, c) == 0 )
        m = c;
        return;
    elseif ( subs(f, c) * subs(f, a) < 0 )
        b = c;
    else
        a = c;
    end
    
    % Ha |b - a| < eps_step, vagyis kellen kicsi az intervallum
    %       |f(a)| < |f(b)| s |f(a)| < eps_abs: f(a) kellen kzel van az x
    %           tengelyhez s kzelebb, mint f(b)
    %       |f(b)| < eps_abs: f(b) kzelebb van az x tengelyhez, mint f(a).
    
    if ( abs( b - a ) < eps_step )
        if ( abs( subs(f, a) ) < abs(  subs(f, b) ) && abs( subs(f, a) ) < eps_abs )
            m = a;
            return;
        elseif ( abs(  subs(f, b) ) < eps_abs )
            m = b;
            return;
        end
    end
end

error( strcat(num2str(N), ' iterciban nem talltunk megoldst.'));
end